package resourcePredictor;

import clusterManagement.ApplicationNotFoundException;
import clusterManagement.ApplicationRepository;
import dataTypes.ResourceType;
import dataTypes.Statistics;

public class ApplicationHistoryDatabaseStub {

	protected ApplicationRepository applicationRepository;

	public ApplicationHistoryDatabaseStub(ApplicationRepository orb) {
		this.applicationRepository = orb;
	}

	public int size(String applicationName) throws ApplicationNotFoundException {
		return applicationRepository
				.getNumberOfApplicationExecutions(applicationName);
	}

	public double getMean(String applicationName, ResourceType resource)
			throws ApplicationNotFoundException {
		return applicationRepository.getApplicationExecutionsStatistic(
				applicationName, resource, Statistics.mean);
	}

	public double getMedian(String applicationName, ResourceType resource)
			throws ApplicationNotFoundException {
		return applicationRepository.getApplicationExecutionsStatistic(
				applicationName, resource, Statistics.median);
	}

	public double getStandardDeviation(String applicationName,
			ResourceType resource) throws ApplicationNotFoundException {
		return applicationRepository.getApplicationExecutionsStatistic(
				applicationName, resource, Statistics.standardDeviation);
	}
}