package resourcePredictor;

/**
 * @author Fábio Augusto Firmo
 * 
 */
public class Prediction {

	private double normalizedExecutionTime;

	private long memory;

	public Prediction(double normalizedExecutionTime, long memory) {
		this.normalizedExecutionTime = normalizedExecutionTime;
		this.memory = memory;
	}

	public Prediction(double normalizedExecutionTime, double memory) {
		this.normalizedExecutionTime = normalizedExecutionTime;
		this.memory = (long) Math.ceil(memory);
	}

	public double getExecutionTime() {
		return normalizedExecutionTime;
	}

	public void setNormalizedExecutionTime(double normalizedExecutionTime) {
		this.normalizedExecutionTime = normalizedExecutionTime;
	}

	public long getMemory() {
		return memory;
	}

	public String generateConstraint(double processorMips) {
		double hours = processorMips * normalizedExecutionTime / 360.0;
		hours = Math.ceil(hours);
		String constraint = "(freeRam >= " + memory + " and hours >= "
				+ (int) hours + " )";
		
		return constraint;
	}
}
