#ifndef RESOURCEMONITOR_HPP_
#define RESOURCEMONITOR_HPP_

#include <iostream>
#include <string>
#include <map>
#include <pthread.h>

#define MAX_BUFFER 5000
#define SLEEP_INTERVAL 5

using std::string;

class ProcessResources {
public:
	double cpu;
	long memory;

	ProcessResources() {}
	virtual ~ProcessResources() {}
};

class ResourceMonitor {
public:
	ResourceMonitor();
	virtual ~ResourceMonitor();
	void startCollectingData();
	static void *collectDataThread(void *resourceMonitor);
	void joinCollectingThread();
	void addPid(int pid);
	void removePid(int pid);
	ProcessResources *getProcessResources(int pid);

private:
	long totalMemory;
	int cores;
	int cpuIndex;
	int memIndex;
	int pidIndex;
	pthread_t collectingThread;
	pthread_mutex_t resourceMonitorLock;
	std::map<int, ProcessResources> processInformations;

	void collectData();
	void findColumns(string header);
	string getColumnValue(string line, int index);
};

#endif /* RESOURCEMONITOR_HPP_ */
